#!/bin/sh
#
# Input: .dmp
# Type: application/x-gzip
# Resource: json
#
# argv[1] = Input object
# argv[2] = Output object
# argv[3] = Symbol directory
# argv[4] = Downloaded missing symbol directory
# argv[5] = Temporary file, if applicable
# argv[6] = Filter command string, if applicable
#

TOOL=/opt/backtrace/bin/minidump_to_json
SYMS=/opt/backtrace/bin/minidump_symbols

GZIP=gzip

if test ! -x "$TOOL"; then
       logger "coronerd requires $TOOL to be installed"
       exit 1
fi

# A conversion command was specified.  Unfortunately, the stack requires
# mapping in a file, which isn't supported for stdin, so it's necessary to
# store the result to a temp file.
DMPPATH="$1"
INPATH="$DMPPATH"
ret=0
if [ -n "$5" ]; then
	INPATH="$5"
	$6 "$DMPPATH" "$INPATH"
	ret=$?
fi

if [ $ret -eq 0 ]; then
	${TOOL} "$INPATH" - --sym "$3" --sym "$4" | ${GZIP} -c > $2
	ret=$?
fi
[ "$DMPPATH" != "$INPATH" ] && rm -f $INPATH
exit $ret
